## ukui-biometric-auth 1.0.2

=== Makefile ===
mode = debug

ARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIB_PATH = /usr/lib/$(ARCH)
PATH_ARGS = UKUI_BIOMETRIC=/usr/share/ukui-biometric INSTALL_ROOT=$(DESTDIR)/
UKUI_BIOMETRIC=/usr/share/ukui-biometric

# Target
all:
	cp polkit-agent/data/polkit-ukui-authentication-agent-1.desktop.in \
		polkit-agent/data/polkit-ukui-authentication-agent-1.desktop
	sed -i 's/@LIB_PATH/\/usr\/lib\/$(ARCH)/g' \
		polkit-agent/data/polkit-ukui-authentication-agent-1.desktop
	$(MAKE) -C pam-biometric/ $(PATH_ARGS)
	qmake bioauth/ $(PATH_ARGS) -o bioauth/Makefile
	$(MAKE) -C bioauth/ $(PATH_ARGS)
	qmake bioauth-bin/ $(PATH_ARGS) -o bioauth-bin/Makefile
	$(MAKE) -C bioauth-bin/ $(PATH_ARGS)
	qmake polkit-agent/ $(PATH_ARGS) -o polkit-agent/Makefile
	$(MAKE) -C polkit-agent/ $(PATH_ARGS)

install: install-pam install-bin install-images install-polkit

install-pam:
	# install pam-biometric
	$(MAKE) -C pam-biometric install $(PATH_ARGS)

install-bin:
	# install bioauth-bin
	$(MAKE) -C bioauth-bin install $(PATH_ARGS)

install-images:
	# install images
	mkdir -p $(DESTDIR)$(UKUI_BIOMETRIC)/images
	install -m 644 -D images/* $(DESTDIR)$(UKUI_BIOMETRIC)/images/

install-polkit:
	# install polkit-ukui-agent
	$(MAKE) -C polkit-agent install $(PATH_ARGS) LIB_PATH=$(LIB_PATH)

uninstall: uninstall-pam uninstall-bin uninstall-images uninstall-polkit

uninstall-pam:
	# uninstall pam-biometric
	$(MAKE) -c pam-biometric uninstall $(PATH_ARGS)

uninstall-bin:
	# uninstall bioauth-bin
	$(MAKE) -C bioauth-bin uninstall $(PATH_ARGS)

uninstall-images:
	# uninstall images
	rm -rf $(DESTDIR)$(UKUI_BIOMETRIC)/images

uninstall-polkit:
	# uninstall polkit-ukui-agent
	$(MAKE) -C polkit-agent uninstall $(PATH_ARGS) LIB_PATH=$(LIB_PATH)

clean:
	# Clean
	$(MAKE) -C bioauth clean
	$(MAKE) -C bioauth-bin clean
	$(MAKE) -C pam-biometric clean
	$(MAKE) -C polkit-agent clean
	rm -f bioauth/i18n_ts/*.qm
	rm -f bioauth-bin/i18n_ts/*.qm
	rm -f polkit-agent/i18n_ts/*.qm
	rm -f polkit-agent/data/polkit-ukui-authentication-agent-1.desktop

distclean:
	# dist clean
	$(MAKE) -C bioauth distclean
	$(MAKE) -C bioauth-bin distclean
	$(MAKE) -C pam-biometric distclean
	$(MAKE) -C polkit-agent distclean

=== pam-biometric/Makefile ===
CC = gcc
CFLAGS = -g -Wall -fPIC
INCLUDE = -I../common
PAM_LDFLAGS = -lpam
PAM_MODULE_DIR = /lib/security
PAM_CONFIGS = /usr/share/pam-configs
OBJS = pam_biometric.o logger.o
UKUI_BIOMETRIC=/usr/share/ukui-biometric
CONFIG_FILE=$(UKUI_BIOMETRIC)/biometric-auth.conf
POLKIT_ACTION_DIR=/usr/share/polkit-1/actions
#ifeq ($(mode), debug)
#	CFLAGS += -g
#else
#	CFLAGS += -O2
#endif

all: pam_biometric.so

pam_biometric.so: $(OBJS)
	$(CC) $(CFLAGS) -shared $^ -o $@ $(INCLUDE) $(PAM_LDFLAGS)

$(OBJS): %.o: %.c
	$(CC) $(CFLAGS) -DUKUI_BIOMETRIC=$(UKUI_BIOMETRIC) -DCONFIG_FILE=$(CONFIG_FILE) -c -o $@ $< $(INCLUDE)

install:
	install -D pam_biometric.so $(INSTALL_ROOT)$(PAM_MODULE_DIR)/pam_biometric.so
	install -m 644 -D pam-configs/pam-biometric $(INSTALL_ROOT)$(PAM_CONFIGS)/pam-biometric
	install -m 644 -D data/biometric-auth.conf $(INSTALL_ROOT)$(UKUI_BIOMETRIC)/biometric-auth.conf
	install -m 644 -D data/org.freedesktop.plicykit.pkexec.bioctl.policy \
		$(INSTALL_ROOT)$(POLKIT_ACTION_DIR)/org.freedesktop.plicykit.pkexec.bioctl.policy
	install -m 755 -D utils/bioctl $(INSTALL_ROOT)/bin/bioctl

uninstall:
	rm -f $(INSTALL_ROOT)$(PAM_MODULE_DIR)/pam_biometric.so
	rm -f $(INSTALL_ROOT)$(PAM_CONFIGS)/pam-biometric
	rm -f $(INSTALL_ROOT)$(UKUI_BIOMETRIC)/biometric-auth.conf
	rm -f $(INSTALL_ROOT)/bin/bioctl
	rm -f $(INSTALL_ROOT)$(POLKIT_ACTION_DIR)/org.freedesktop.plicykit.pkexec.bioctl.policy

clean:
	rm -f *.o
distclean:
	rm -f *.o
	rm -f pam_biometric.so

=== debian/changelog ===
ukui-biometric-auth (1.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #908469)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 25 Sep 2018 15:37:06 +0800

=== debian/control ===
Source: ukui-biometric-auth
Section: admin
Priority: optional
Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: debhelper (>= 11),
               qtbase5-dev,
               libpam-dev,
               libpolkit-qt5-1-dev,
               qttools5-dev-tools,
			   pkg-config
Standards-Version: 4.2.1
Homepage: http://www.ukui.org
Vcs-Git: https://salsa.debian.org/kylin-team/ukui-biometric-auth.git
Vcs-Browser: https://salsa.debian.org/kylin-team/ukui-biometric-auth

Package: libpam-biometric
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: biometric-auth
Description: Insertable authentication module for PAM
 The indispensable part for biometric authentication in
 ukui desktop environment.
 This package contains a modules for PAM.

Package: ukui-polkit
Architecture: any
Depends: policykit-1,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: biometric-auth
Description: UKUI authentication agent for PolicyKit-1
 The ukui-polkit package supports general authentication and
 biometric authentication that the service is provided by the
 biometric-auth package.

## ukui-biometric-auth 1.0.3

=== debian/changelog ===
ukui-biometric-auth (1.0.3-2ubuntu0.1) eoan; urgency=medium

  * Debian/patchs:
    - Add fix-segfault-after-close-polkit-window.patch. (LP: #1856690)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 17 Dec 2019 19:44:17 +0800

ukui-biometric-auth (1.0.3-2) experimental; urgency=medium

  * Debian/control:
    - libpam-biometric: Breaks and Replaces ukui-polkit(<<1.0.3)
      (Closes: #925377)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 27 Mar 2019 11:58:32 +0800

ukui-biometric-auth (1.0.3-1) experimental; urgency=medium

  * The dialog of su or sudo is replaced by command output.
  * Autorestart biometric authentication if authentication failed.
  * Change the path of some config files.
  * Add biodrvctl script to control driver status.
  * Add fr/pt/ru/es translation.
  * Add a series of biometric image.
  * migrate to cmake.
  * Fix the bug that polit can't load qm file.
  * Fix the bug that polkit can't load icon.
  * Fix the bug that polkit doesn't exit when logout.
  * debian/control:
   - Now ukui-polkit provides polkit-1-auto-agent.
   - Bump standards-version to 4.3.0.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 21 Mar 2019 10:55:27 +0800

=== debian/control ===
Source: ukui-biometric-auth
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: debhelper (>= 11),
               cmake (>= 2.6),
               qtbase5-dev,
               libpam-dev,
               libpolkit-qt5-1-dev,
               qttools5-dev,
               qttools5-dev-tools,
               pkg-config
Standards-Version: 4.3.0
Homepage: https://github.com/ukui/ukui-biometric-auth
Vcs-Git: https://github.com/ukui/ukui-biometric.git
Vcs-Browser: https://github.com/ukui/ukui-biometric-auth

Package: libpam-biometric
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: biometric-auth
Breaks: ukui-polkit (<<1.0.3)
Replaces: ukui-polkit (<<1.0.3)
Description: Insertable authentication module for PAM
 The indispensable part for biometric authentication in
 ukui desktop environment.
 This package contains a modules for PAM.

Package: ukui-polkit
Architecture: any
Depends: policykit-1,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: biometric-auth
Provides: polkit-1-auth-agent
Description: UKUI authentication agent for PolicyKit-1
 The ukui-polkit package supports general authentication and
 biometric authentication that the service is provided by the
 biometric-auth package.

## ukui-biometric-auth 1.0.4

=== debian/changelog ===
ukui-biometric-auth (1.0.4-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release.
  * debian/control:
    - Bump standards-version to 4.4.1. No changes needed.
  * debian/{compat,control}:
    - Use debhelper-compat notation. Bump to DH compat level
      version 12.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 30 Nov 2019 17:16:35 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: ukui-biometric-auth
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                cmake (>= 2.6),
                qtbase5-dev,
                libpam-dev,
@@ -12,7 +11,8 @@
                qttools5-dev,
                qttools5-dev-tools,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
+Rules-Requires-Root: no
 Homepage: https://github.com/ukui/ukui-biometric-auth
 Vcs-Git: https://github.com/ukui/ukui-biometric.git
 Vcs-Browser: https://github.com/ukui/ukui-biometric-auth

## ukui-biometric-auth 1.2.0

=== bioauth-bin/CMakeLists.txt ===
project(bioauth-bin)

set(CMAKE_AUTOMOC ON)

include_directories(
    ../common
    ../bioauth/include
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
    )

set(bin_SRCS
    ${bin_SRCS}
    src/main.cpp
    src/keywatcher.cpp
    ../common/generic.cpp
    )

add_executable(bioauth ${bin_SRCS})
target_link_libraries(bioauth Qt5::Core BioAuth)

install(TARGETS bioauth DESTINATION bin)

file(GLOB ts_files i18n_ts/*.ts)
qt5_add_translation(qm_files ${ts_files})
add_custom_target(bioauth-bin_i18n DEPENDS ${qm_files} SOURCES ${ts_files})
add_dependencies(bioauth bioauth-bin_i18n)

install(FILES ${qm_files} DESTINATION ${UKUI_BIOMETRIC_DIR}/i18n_qm/bioauth-bin)

=== polkit-agent/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(ukui-polkit-agent)


find_package(PolkitQt5-1 REQUIRED 0.103.0)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(LIB_ARCH_PATH /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE})

configure_file(
    ${PROJECT_SOURCE_DIR}/data/polkit-ukui-authentication-agent-1.desktop.in
    ${PROJECT_BINARY_DIR}/data/polkit-ukui-authentication-agent-1.desktop
    )


include_directories(
    ${POLKITQT-1_INCLUDE_DIR}
    ../common
    ../bioauth/include
    )

qt5_add_resources(polkit_SRCS assets.qrc)

set(polkit_SRCS
    ${polkit_SRCS}
    src/PolkitAgent.cpp
    src/mainwindow.cpp
    src/PolkitListener.cpp
    src/sessionmanager.cpp
    ../common/generic.cpp
    )

add_executable(polkit-ukui-authentication-agent-1 ${polkit_SRCS})
target_link_libraries(polkit-ukui-authentication-agent-1
    Qt5::Core Qt5::Widgets Qt5::DBus
    ${POLKITQT-1_LIBRARIES}
    BioAuthWidgets
    )
install(TARGETS polkit-ukui-authentication-agent-1
    DESTINATION lib/${CMAKE_LIBRARY_ARCHITECTURE}/ukui-polkit)

# 翻译文件
file(GLOB ts_files i18n_ts/*.ts)
qt5_add_translation(qm_files ${ts_files})
add_custom_target(polkit_i18n DEPENDS ${qm_files} SOURCES ${ts_files})
add_dependencies(polkit-ukui-authentication-agent-1 polkit_i18n)

install(FILES ${qm_files} DESTINATION ${UKUI_BIOMETRIC_DIR}/i18n_qm/polkit)
install(FILES ${PROJECT_BINARY_DIR}/data/polkit-ukui-authentication-agent-1.desktop
    DESTINATION /etc/xdg/autostart)

=== debian/changelog ===
ukui-biometric-auth (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    - Bump standards-vertion to 4.5.0.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 24 Feb 2020 22:07:07 +0800

## ukui-biometric-auth 1.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(ukui-biometric-auth)

find_package(Qt5 COMPONENTS Core Widgets DBus)
find_package(Qt5LinguistTools)

set(UKUI_BIOMETRIC_DIR /usr/share/ukui-biometric)
set(CMAKE_INSTALL_PREFIX /usr)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 11)
set (CONDOR_SCRIPT_PERMS OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

add_compile_options(-fPIC)
add_definitions(-DUKUI_BIOMETRIC=${UKUI_BIOMETRIC_DIR})
add_definitions(-DCONFIG_FILE=/etc/biometric-auth/ukui-biometric.conf)


add_subdirectory(bioauth)
add_subdirectory(bioauth-bin)
add_subdirectory(pam-biometric)
add_subdirectory(polkit-agent)
add_subdirectory(images)

add_dependencies(bioauth BioAuth)
add_dependencies(polkit-ukui-authentication-agent-1 BioAuthWidgets)

=== bioauth/CMakeLists.txt ===
qt5_wrap_ui(BioAuthWidgets_SRC
	src/bioauthwidget.ui
	src/biodeviceswidget.ui
	)

qt5_wrap_cpp(BioAuth_SRC
    include/bioauth.h
    include/biodevices.h
    )
qt5_wrap_cpp(BioAuthWidgets_SRC
    include/bioauthwidget.h
	include/biodeviceswidget.h
	)

set(BioAuth_SRC
	${BioAuth_SRC}
	src/bioauth.cpp
	src/biodevices.cpp
	src/biotypes.cpp
    )

set(BioAuthWidgets_SRC
    ${BioAuthWidgets_SRC}
    src/bioauthwidget.cpp
	src/biodeviceswidget.cpp
	)

include_directories(
	${Qt5Core_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
	${Qt5DBus_INCLUDE_DIRS}
	include
    ../common
	)
add_library(BioAuth STATIC ${BioAuth_SRC})
target_link_libraries(BioAuth Qt5::Core Qt5::DBus)
add_library(BioAuthWidgets STATIC ${BioAuthWidgets_SRC})
target_link_libraries(BioAuthWidgets BioAuth Qt5::Widgets)
#add_library(BioAuth OBJECT ${BioAuth_SRC})
#add_library(BioAuthWidgets OBJECT ${BioAuth_SRC} ${BioAuthWidgets_SRC})

file(GLOB ts_files i18n_ts/*.ts)
qt5_add_translation(qm_files ${ts_files})
add_custom_target(bioauth_i18n DEPENDS ${qm_files} SOURCES ${ts_files})
add_dependencies(BioAuth bioauth_i18n)

install(FILES ${qm_files} DESTINATION ${UKUI_BIOMETRIC_DIR}/i18n_qm)

=== pam-biometric/CMakeLists.txt ===
project(pam_biometric)

find_path(PAM_INCLUDE_DIR security/pam_modules.h)
find_library(PAM_LIB NAMES pam)

if(NOT PAM_INCLUDE_DIR OR NOT PAM_LIB)
    message(FATAL_ERROR "pam_modules.h not found")
endif()

set(SCRIPTS_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/bin)
configure_file(
    ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy.in
    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy
    )
configure_file(
    ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy.in
    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy
    )

set(pam_SRCS
    pam_biometric.c
    logger.c
    )

include_directories(
    ../common
    ${PAM_INCLUDE_DIR}
    )


add_library(pam_biometric SHARED ${pam_SRCS})
target_link_libraries(pam_biometric ${PAM_LIB})
#去除lib前缀
set_target_properties(pam_biometric PROPERTIES PREFIX "")

install(TARGETS pam_biometric DESTINATION /lib/security)
install(FILES pam-configs/pam-biometric DESTINATION /usr/share/pam-configs)
install(FILES data/ukui-biometric.conf DESTINATION /etc/biometric-auth)
install(FILES
    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy
    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy
    DESTINATION /usr/share/polkit-1/actions
    )
install(FILES utils/bioctl utils/biodrvctl DESTINATION bin PERMISSIONS ${CONDOR_SCRIPT_PERMS})

=== debian/changelog ===
ukui-biometric-auth (1.2.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 27 Sep 2020 14:57:48 +0800

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                qttools5-dev,
                qttools5-dev-tools,
                pkg-config
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/ukui/ukui-biometric-auth
 Vcs-Git: https://github.com/ukui/ukui-biometric.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ukui-biometric-auth-$1\.tar\.gz/ \
  https://github.com/ukui/ukui-biometric-auth/releases .*/v?(\d\S+)\.tar\.gz

## ukui-biometric-auth 1.2.2

=== debian/changelog ===
ukui-biometric-auth (1.2.2-1build1) jammy; urgency=medium

  * No-change rebuild against libopencv-core4.5d

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 00:52:41 +0000

ukui-biometric-auth (1.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 18 Aug 2021 19:30:31 +0800

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: ukui-biometric-auth
 Section: admin
 Priority: optional
-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
 Build-Depends: debhelper-compat (= 12),
                cmake (>= 2.6),
                qtbase5-dev,
                libpam-dev,
+               libglib2.0-dev,
+	       libopencv-dev,
                libpolkit-qt5-1-dev,
                qttools5-dev,
                qttools5-dev-tools,

## ukui-biometric-auth 1.2.2.1

=== debian/changelog ===
ukui-biometric-auth (1.2.2.1-2) unstable; urgency=medium

  * d/control: drop policykit-1, add pkexec. (Closes: #1025633)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 21 Aug 2023 13:47:48 +0800

ukui-biometric-auth (1.2.2.1-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix FTBFS with new glib. (Closes: #1019990)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 17 Oct 2022 17:57:05 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ukui-biometric-auth
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
 Build-Depends: debhelper-compat (= 12),
                cmake (>= 2.6),
@@ -23,7 +22,8 @@
 Package: libpam-biometric
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: biometric-auth
+Suggests: biometric-auth,
+          pkexec
 Breaks: ukui-polkit (<<1.0.3)
 Replaces: ukui-polkit (<<1.0.3)
 Description: Insertable authentication module for PAM
@@ -33,8 +33,7 @@
 
 Package: ukui-polkit
 Architecture: any
-Depends: policykit-1,
-         ${shlibs:Depends},
+Depends: ${shlibs:Depends},
          ${misc:Depends}
 Suggests: biometric-auth
 Provides: polkit-1-auth-agent

## ukui-biometric-auth 1.2.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,15 @@
 
 find_package(Qt5 COMPONENTS Core Widgets DBus)
 find_package(Qt5LinguistTools)
+find_package(OpenCV REQUIRED)
+find_package(PkgConfig)
+pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
+pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)
 
 set(UKUI_BIOMETRIC_DIR /usr/share/ukui-biometric)
 set(CMAKE_INSTALL_PREFIX /usr)
 
+#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_CXX_STANDARD 11)
 set (CONDOR_SCRIPT_PERMS OWNER_READ OWNER_WRITE OWNER_EXECUTE

=== polkit-agent/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
     src/mainwindow.cpp
     src/PolkitListener.cpp
     src/sessionmanager.cpp
+    src/users.cpp
     ../common/generic.cpp
     )

=== debian/changelog ===
ukui-biometric-auth (1.2.2.2-1) unstable; urgency=medium

  * Fix implicit function declaration (Closes: 1066602)
  * Update debian/wathch.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 02 Apr 2024 11:46:17 +0800

=== debian/control ===
Source: ukui-biometric-auth
Section: admin
Priority: optional
Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: cmake (>= 2.6),
               debhelper-compat (= 12),
               libglib2.0-dev,
               libopencv-dev,
               libpam-dev,
               libpolkit-qt5-1-dev,
               pkgconf,
               qtbase5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://gitee.com/openkylin/ukui-biometric-auth
Vcs-Git: https://gitee.com/openkylin/ukui-biometric.git
Vcs-Browser: https://gitee.com/openkylin/ukui-biometric-auth

Package: libpam-biometric
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: biometric-auth, pkexec
Breaks: ukui-polkit (<<1.0.3)
Replaces: ukui-polkit (<<1.0.3)
Description: Insertable authentication module for PAM
 The indispensable part for biometric authentication in
 ukui desktop environment.
 This package contains a modules for PAM.

Package: ukui-polkit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: biometric-auth
Provides: polkit-1-auth-agent
Description: UKUI authentication agent for PolicyKit-1
 The ukui-polkit package supports general authentication and
 biometric authentication that the service is provided by the
 biometric-auth package.

## ukui-biometric-auth 1.2.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.5)
 project(ukui-biometric-auth)
 
 find_package(Qt5 COMPONENTS Core Widgets DBus)

=== bioauth/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 qt5_wrap_cpp(BioAuthWidgets_SRC
     include/bioauthwidget.h
 	include/biodeviceswidget.h
+	include/giodbus.h
 	)
 
 set(BioAuth_SRC
@@ -23,19 +24,20 @@
     ${BioAuthWidgets_SRC}
     src/bioauthwidget.cpp
 	src/biodeviceswidget.cpp
+	src/giodbus.cpp
 	)
-
 include_directories(
 	${Qt5Core_INCLUDE_DIRS}
-    ${Qt5Widgets_INCLUDE_DIRS}
+        ${Qt5Widgets_INCLUDE_DIRS}
 	${Qt5DBus_INCLUDE_DIRS}
+	${GLIB2_INCLUDE_DIRS}
 	include
-    ../common
+        ../common
 	)
 add_library(BioAuth STATIC ${BioAuth_SRC})
 target_link_libraries(BioAuth Qt5::Core Qt5::DBus)
 add_library(BioAuthWidgets STATIC ${BioAuthWidgets_SRC})
-target_link_libraries(BioAuthWidgets BioAuth Qt5::Widgets)
+target_link_libraries(BioAuthWidgets BioAuth Qt5::Widgets ${OpenCV_LIBS} ${GIOUNIX2_LIBRARIES})
 #add_library(BioAuth OBJECT ${BioAuth_SRC})
 #add_library(BioAuthWidgets OBJECT ${BioAuth_SRC} ${BioAuthWidgets_SRC})

=== images/CMakeLists.txt ===
file(GLOB images LIST_DIRECTORIES false *.png *.gif)

file(GLOB children *)
set(dirlist "")
foreach(child ${children})
    if(IS_DIRECTORY ${child})
        list(APPEND dirlist ${child})
    endif()
endforeach()

install(FILES ${images} DESTINATION ${UKUI_BIOMETRIC_DIR}/images)
install(DIRECTORY ${dirlist} DESTINATION ${UKUI_BIOMETRIC_DIR}/images)

=== pam-biometric/CMakeLists.txt ===
--- 
+++ 
@@ -9,12 +9,16 @@
 
 set(SCRIPTS_INSTALL_PATH ${CMAKE_INSTALL_PREFIX}/bin)
 configure_file(
-    ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy.in
-    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy
+    ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl-helper.policy.in
+    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl-helper.policy
     )
 configure_file(
     ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy.in
     ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy
+    )
+configure_file(
+    ${PROJECT_SOURCE_DIR}/data/org.freedesktop.plicykit.pkexec.biorestart.policy.in
+    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biorestart.policy
     )
 
 set(pam_SRCS
@@ -37,8 +41,9 @@
 install(FILES pam-configs/pam-biometric DESTINATION /usr/share/pam-configs)
 install(FILES data/ukui-biometric.conf DESTINATION /etc/biometric-auth)
 install(FILES
-    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl.policy
+    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.bioctl-helper.policy
     ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biodrvctl.policy
+    ${PROJECT_BINARY_DIR}/data/org.freedesktop.plicykit.pkexec.biorestart.policy
     DESTINATION /usr/share/polkit-1/actions
     )
-install(FILES utils/bioctl utils/biodrvctl DESTINATION bin PERMISSIONS ${CONDOR_SCRIPT_PERMS})
+install(FILES utils/bioctl utils/bioctl-helper utils/biodrvctl utils/biorestart DESTINATION bin PERMISSIONS ${CONDOR_SCRIPT_PERMS})

=== polkit-agent/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.5)
 project(ukui-polkit-agent)

=== debian/changelog ===
ukui-biometric-auth (1.2.2.3-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix FTBFS with GCC 15. (Closes: #1098033)
  * Fix FTBFS with CMake 4. (Closes: #1113599)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 03 Nov 2025 17:11:16 +0800

ukui-biometric-auth (1.2.2.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Michael Biebl ]
  * Install PAM module into /usr. (Closes: #1063620)
  * Bump debhelper-compat to 13 to get variable expansion in .install files.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 17 Jun 2024 00:14:11 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export QT_SELECT := qt5
export NO_PKG_MANGLE=1

%:
	dh $@

=== debian/watch ===
version=4
https://gitee.com/openkylin/ukui-biometric-auth/releases/ .*/ukui-biometric-auth-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
